// dVector.inc
// dVector class  version 0.6
// by John Siino  date 01/07/2007
// based on example by Paul Turley

// ----------------------------------------------------------------------
class dVector : dataVector       // Class for Column Vector of doubles
{
  //member functions
  declare ScalarProd(double value);      // scalar product A = sA

  declare Add(dVector B), uint;          // add vectors   A = A + B  
  declare Subt(dVector B), uint;         // subtract vectors  A = A - B

  declare Magnitude(), double;           // scalar magnitude of vector (a1^2 + a2^2 + a3^2 + ... )^0.5

  declare DotProd(dVector B), double;    // Dot Product of vectors (s = A(T) * B) result is scalar (double)

  declare AngleR(dVector B), double;     // Angle between two vectors is scalar (double) in radians
  declare AngleD(dVector B), double;     // Angle between two vectors is scalar (double) in degrees

  declare Add2(dVector B, dVector C), uint;   // add vectors   A = B + C
  declare Subt2(dVector B, dVector C), uint;  // subtract vectors A = B - C

  declare Distance(dVector B), double;   // scalar distance between two vectors ((a1-b1)^2 + (a2-b2)^2 + ... )^0.5  

  declare NormalizeVector(dVector B), uint;   // normalized vector for B such that A = B/|B|   * revised to be consistant
  declare Normalize(), uint;                  // normalizes vector A = A/|A|

  declare CrossProd(dVector B, dVector C), uint; // Cross Product of 3d vectors A = B x C results in column vector

  declare ProjectOnVector(dVector B), uint;              // vector A = vector A projected onto Vector B
  declare ProjectOnVector2(dVector B, dVector C), uint;  // vector A = vector B projected onto Vector C

  declare Orthogonal(dVector B), uint;             // vector A = Normalized vector orthogonal to B in direction of original A

  declare Orthogonal2(dVector B, dVector C), uint; // vector A = Normalized Vector orthogonal to B & C (3D only)

  declare Rotate3D(dVector B, double AX, double AY, double AZ), uint;  // vector A = vector B rotated about x, y & z axes (3D only - angles in radians)
  declare Rotate3DD(dVector B, double AX, double AY, double AZ), uint; // vector A = vector B rotated about x, y & z axes (3D only - angles in degrees)

//  declare Spherical(dVector B), uint;              // vector A = vector B in spherical coordinates (3D only - angles in radians)
//  declare SphericalD(dVector B), uint;             // vector A = vector B in spherical coordinates (3D only - angles in degrees)

}
